Index: /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 2006)
+++ /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 2007)
@@ -162,4 +162,5 @@
       real :: zlocal(nlayer)       ! Altitude (km)
       real :: zycol(nlayer,nq)     ! Composition (mole fractions)
+      real :: zmmean(nlayer)       ! Mean molecular mass (g.mole-1)
       real :: szacol               ! Solar zenith angle
       real :: surfice1d(nlayer)    ! Ice surface area (cm2/cm3)
@@ -169,4 +170,7 @@
       real :: em_o2(nlayer)        !  O2 nightglow emission rate      
 
+      integer :: iter(nlayer)      !  Number of chemical iterations
+                                   !  within one physical timestep 
+
 !     for output:
 
@@ -176,4 +180,6 @@
       real :: emission_no(ngrid,nlayer) !NO emission rate
       real :: emission_o2(ngrid,nlayer) !O2 emission rate
+      real :: iter_3d(ngrid,nlayer) ! Number of chemical iterations
+                                    !  within one physical timestep
 
 !=======================================================================
@@ -296,4 +302,44 @@
             niq(nbq) = i_n2
          end if
+         i_n = igcm_n
+         if (i_n == 0) then
+            if (photochem) then
+               write(*,*) "calchim: Error; no N tracer !!!"
+               stop
+            end if
+         else
+            nbq = nbq + 1
+            niq(nbq) = i_n
+         end if
+         i_n2d = igcm_n2d
+         if (i_n2d == 0) then
+            if (photochem) then
+               write(*,*) "calchim: Error; no N2D tracer !!!"
+               stop
+            end if
+         else
+            nbq = nbq + 1
+            niq(nbq) = i_n2d
+         end if
+         i_no = igcm_no
+         if (i_no == 0) then
+            if (photochem) then
+               write(*,*) "calchim: Error; no NO tracer !!!"
+               stop
+            end if
+         else
+            nbq = nbq + 1
+            niq(nbq) = i_no
+         end if
+         i_no2 = igcm_no2
+         if (i_no2 == 0) then
+            if (photochem) then
+               write(*,*) "calchim: Error; no NO2 tracer !!!"
+               stop
+            end if
+         else
+            nbq = nbq + 1
+            niq(nbq) = i_no2
+         end if
          i_h2o = igcm_h2o_vap
          if (i_h2o == 0) then
@@ -310,11 +356,8 @@
             !NO is used to determine if N chemistry is wanted
             !chemthermod=2 -> N chemistry
-            i_no = igcm_no
             if (i_no == 0) then
                write(*,*) "calchim: no NO tracer"
                write(*,*) "C/O/H themosp chemistry only "
             else
-               nbq = nbq + 1
-               niq(nbq) = i_no
                chemthermod=2
                write(*,*) "calchim: NO in traceur.def"
@@ -322,5 +365,4 @@
             end if
             ! N
-            i_n = igcm_n
             if(chemthermod == 2) then
                if (i_n == 0) then
@@ -328,50 +370,17 @@
                   write(*,*) "N is needed if NO is in traceur.def"
                   stop
-               else
-                  nbq = nbq + 1
-                  niq(nbq) = i_n
-               end if
-            else 
-               if (i_n /= 0) then
-                  write(*,*) "calchim: Error: N is present, but NO is not!!!"
-                  write(*,*) "Both must be in traceur.def if N chemistry is wanted"
-                  stop
-               endif
-            endif    !Of if(chemthermod == 2) 
+               end if
             ! NO2
-            i_no2 = igcm_no2
-            if(chemthermod == 2) then
                if (i_no2 == 0) then
                   write(*,*) "calchim: Error; no NO2 tracer !!!"
                   write(*,*) "NO2 is needed if NO is in traceur.def"
                   stop
-               else
-                  nbq = nbq + 1
-                  niq(nbq) = i_no2
-               end if
-            else
-               if (i_no2 /= 0) then
-                  write(*,*) "calchim: Error: N is present, but NO is not!!!"
-                  write(*,*) "Both must be in traceur.def if N chemistry is wanted"
-                  stop
-               endif
-            endif     !Of if(chemthermod == 2)
+               end if
             ! N(2D)
-            if(chemthermod == 2) then
-               i_n2d = igcm_n2d
                if (i_n2d == 0) then
                   write(*,*) "calchim: Error; no N2D !!!"
                   write(*,*) "N2D is needed if NO is in traceur.def"
                   stop
-               else
-                  nbq = nbq + 1
-                  niq(nbq) = i_n2d
-               end if
-            else
-               if (i_n2d /= 0) then
-                  write(*,*) "calchim: Error: N2D is present, but NO is not!!!"
-                  write(*,*) "Both must be in traceur.def if N chemistry wanted"
-                  stop
-               endif
+               end if
             endif    !Of if(chemthermod == 2)
             ! Ions
@@ -614,4 +623,5 @@
             zdens(l)  = zpress(l)/(kb*1.e4*ztemp(l))
             zlocal(l) = zzlay(ig,l)/1000.
+            zmmean(l) = mmean(ig,l)
 
 !           surfdust1d and surfice1d: conversion from m2/m3 to cm2/cm3
@@ -647,8 +657,9 @@
 
          if (photochem) then
-            call photochemistry(nlayer,nq,                         &
-                                lswitch,zycol,szacol,ptimestep,    &
-                                zpress,ztemp,zdens,dist_sol,       &
-                                surfdust1d,surfice1d,jo3,taucol)
+
+            call photochemistry(nlayer,nq,                            &
+                                ig,lswitch,zycol,szacol,ptimestep,    &
+                                zpress,ztemp,zdens,zmmean,dist_sol,   &
+                                surfdust1d,surfice1d,jo3,taucol,iter)
 
 !        ozone photolysis, for output
@@ -656,4 +667,5 @@
             do l = 1,nlayer
                jo3_3d(ig,l) = jo3(l)
+               iter_3d(ig,l) = iter(l)
             end do
 
@@ -684,4 +696,5 @@
                             zu, zv, zt, zycol, ptimestep, co2ice)
          end if
+
 !=======================================================================
 !     tendencies
@@ -693,4 +706,5 @@
 
 !     tendency for the most abundant species = - sum of others
+
          do l = 1,nlayer
             iloc=maxloc(zycol(l,:))
@@ -724,4 +738,6 @@
             call writediagfi(ngrid,'jo3','j o3->o1d',    &
                              's-1',3,jo3_3d(1,1))
+            call writediagfi(ngrid,'iter','iterations',  &
+                             ' ',3,iter_3d(1,1))
             call writediagfi(ngrid,'emission_no',        &
                  'NO nightglow emission rate','cm-3 s-1',3,emission_no)
@@ -729,12 +745,14 @@
                  'O2 nightglow emission rate','cm-3 s-1',3,emission_o2)
 
-           if (callstats) then
-              call wstats(ngrid,'jo3','j o3->o1d',       &
-                          's-1',3,jo3_3d(1,1))
-              call wstats(ngrid,'emission_no',           &
+            if (callstats) then
+               call wstats(ngrid,'jo3','j o3->o1d',       &
+                           's-1',3,jo3_3d(1,1))
+               call wstats(ngrid,'emission_no',           &
                    'NO nightglow emission rate','cm-3 s-1',3,emission_no)
-              call wstats(ngrid,'emission_o2',           &
+               call wstats(ngrid,'emission_o2',           &
                    'O2 nightglow emission rate','cm-3 s-1',3,emission_o2)
-           endif
+               call wstats(ngrid,'mmean','mean molecular mass',       &
+                           'g.mole-1',3,mmean(1,1))
+            endif
          end if ! of if (ngrid.gt.1)
       end if ! of if (output)
@@ -742,3 +760,2 @@
       return
       end
-
